#line 7 "/home/dodo/tmp/usbmo/src/plist.u"
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>
#line 21 "/home/dodo/tmp/usbmo/src/plist.u"
typedef struct plist plist_t;

#line 26 "/home/dodo/tmp/usbmo/src/plist.u"

#define PLIST_SIZE  40
struct plist_node { void* data[PLIST_SIZE]; int len;
                     struct plist_node *next;};
struct plist { struct plist_node *first, *last; };

#line 16 "plist.c"

plist_t *plist();
void plista(plist_t *L, void *A);
void plistg(plist_t *L, void ***A, int *N);
void plistf(plist_t *L);
#line 33 "/home/dodo/tmp/usbmo/src/plist.u"

plist_t *plist()
{
  plist_t *L;
  L= malloc(sizeof(*L));
  L->first= L->last= NULL;
  return L;
}

void plista(plist_t *L, void *A)
{
  if (!L->last || L->last->len==PLIST_SIZE)
  {
     struct plist_node *N;
     N= malloc(sizeof(*N));
     N->next= NULL;
     N->len= 0;
     if (L->last) L->last->next= N; 
     else L->first= N;
     L->last= N;
  }
  L->last->data[L->last->len++]= A;
}

void plistg(plist_t *L, void ***A, int *N)
{
  struct plist_node *X,*Y;
  int S;
  void **D;

  S= 0;
  for(X=L->first;X;X=X->next) S+= X->len;

  D= malloc((S+1)*sizeof(void*));
  S= 0;

  for(X=L->first;X;X=Y)
  {
     memcpy(D+S, X->data, X->len*sizeof(void*));
     S+= X->len; Y= X->next;
     free(X);
  }

  free(L);
  *A= D;
  *N= S;
}

void plistf(plist_t *L)
{
  struct plist_node *X,*Y;
  for(X=L->first;X;X=Y) { Y= X->next; free(X); }
  free(L);
}

#line 17 "/home/dodo/tmp/usbmo/src/plist.u"

