

static void quicksort_ptrR(void **A, int left, int right,
                   int (*compar)(void *,void*, void*), void *arg)
{
  int ppos,i,R;
  void *V;

  if (right<=left) return ;
  ppos=left;

  for(i=left;i<right;i++)
    if ((*compar)(A[i], A[right],  arg)<=0)
    {
      V= A[i];
      A[i]= A[ppos];
      A[ppos]= V;
      ppos++;
    }

  V= A[ppos];
  A[ppos]= A[right];
  A[right]= V;
  quicksort_ptrR(A, left, ppos-1, compar, arg);
  quicksort_ptrR(A, ppos+1, right, compar, arg);
}

void quicksort_ptr(void **A, int N, 
                   int (*compar)(void *,void*, void*), void *arg)
{
  quicksort_ptrR(A, 0, N-1, compar, arg);
}
